IMPLEMENTATION MODULE DrvSnd;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    **************************************************************************
    Hardware :  PC AT BIOS-compatibles
    Compilers:  TopSpeed / Stony Brook Modula-2
    --------------------------------------------------------------------------
    A.Iakovlev  Ver  1.0  Derived from ITC's Sound                 March 89
    A.Iakovlev  Ver  1.1  LOGITECH's delay in milliseconds!        July 89
    A.Iakovlev  Ver  1.2  Use M2VERS utility                       August 89
    A.Iakovlev  Ver  2.0  Renaming                                 January 90
    A.Iakovlev  Ver  2.1  JPI-only version                         January 90
    A.Iakovlev  Ver  2.2  Conditional compilation for MS-DOS/OS2   July 90
    A.Iakovlev  Ver  2.3  Use switch module OpSystem               July 90
    D.Maslov    Ver  3.0  Beep from PC Magazine, vol.8 (1989) no.1 January 91
    A.Iakovlev  Ver  3.1  Use %T DOS instead of %F OS2             January 92
    A.Iakovlev  Ver  4.0  Renaming                                 June 93
    A.Iakovlev  Ver  4.1  No OS/2 support                          February 94
    A.Iakovlev  Ver  4.2  Stony Brook support                      February 94
    A.Iakovlev  Ver  5.0  Renaming                                 March 95
    **************************************************************************
    TopSpeed library dependencies:
    ------ import from Lib: Sound, NoSound
    Stony Brook library dependencies:
    ------ import from Speaker: StartTone, EndTone
  *)

  FROM Cfg IMPORT CMPTS, CMPSB;
  IMPORT DrvClk;

  (* ========================== Conditional import *)

  (*%T CMPTS*)
  IMPORT Lib;
  (*%E*)

  (*%T CMPSB*)
  IMPORT Speaker;
  (*%E*)

  (* ===================================== Library interface *)

  (*%T CMPTS*)

  PROCEDURE Tone(freq, duration: CARDINAL);
    BEGIN
      Lib.Sound(freq);
      DrvClk.Delay(duration);
      Lib.NoSound();
    END Tone;

  (*%E*)

  (*%T CMPSB*)

  PROCEDURE Tone(freq, duration: CARDINAL);
    BEGIN
      Speaker.StartTone(VAL(LONGINT, freq) * 10);
      DrvClk.Delay(duration);
      Speaker.EndTone();
    END Tone;

  (*%E*)

  (* =============================================== Universal Beep *)

  PROCEDURE Beep(start, end, step, delay, times, pause: CARDINAL);
    VAR
      stepCount, sc: CARDINAL;
      a, s: INTEGER;
    BEGIN
      IF start > end THEN
        stepCount := start - end;
        s := - VAL(INTEGER, step);
      ELSE
        stepCount := end - start;
        s := VAL(INTEGER, step);
      END;
      stepCount := stepCount DIV step;
      WHILE times > 0 DO
        DEC(times);
        a := VAL(INTEGER, start);
        sc := stepCount;
        WHILE sc > 0 DO
          DEC(sc);
          Tone(a, delay);
          INC(a, s);
        END;
        DrvClk.Delay(pause);
      END;
    END Beep;

  (* ============================== Standard noises *)

  PROCEDURE Error();
    BEGIN
      Beep(750, 2250, 250, 20, 1, 0);
    END Error;

  PROCEDURE Urgent();
    BEGIN
      Beep(500, 4500, 500, 30, 1, 0);
    END Urgent;

  PROCEDURE Attention();
    BEGIN
      Beep(600, 1400, 200, 10, 2, 0);
    END Attention;

  PROCEDURE Success();
    BEGIN
      Beep(100, 200, 100, 10, 1, 0);
    END Success;

  END DrvSnd.
