IMPLEMENTATION MODULE ScrBas;
  (*
    Copyright (C) 1993-1995, Alex Iakovlev & Dimon Maslov
    **************************************************************************
    Hardware :  IBM PC/XT/AT ROM BIOS
    OpSystem :  MS-DOS & TopSpeed DOS Extender
    Compilers:  TopSpeed / Stony Brook Modula-2
    --------------------------------------------------------------------------
    A.Iakovlev  Ver  1.0  Initial version                          May 91
    A.Iakovlev  Ver  2.0  No switch parameter                      January 92
    A.Iakovlev  Ver  2.1  Vio.CONFIGINFO + GetVersion for TS 3.02  January 92
    A.Iakovlev  Ver  2.2  Version for TopSpeed DOS Extender        January 92
    A.Iakovlev  Ver  2.3  CGA testing via separate module RM       January 92
    A.Iakovlev  Ver  3.0  Pragma data(var_enum_size)               August 92
    A.Iakovlev  Ver  4.0  Renaming                                 June 93
    A.Iakovlev  Ver  4.1  No use SHORTCARD type                    January 94
    A.Iakovlev  Ver  4.2  Erasure of all the CGA code              January 94
    A.Iakovlev  Ver  4.3  No OS/2 support                          February 94
    A.Iakovlev  Ver  4.4  Use module SrvSys                        February 94
    A.Iakovlev  Ver  5.0  No memory variable                       March 94
    A.Iakovlev  Ver  6.0  Renaming                                 March 95
    **************************************************************************
    MS-DOS dependencies:
    ------ video driver at INT 10H (function 1AH)
    TopSpeed DOS Extender dependencies:
    ------ necessity to initialize the interceptor for the video interrupt
    ------ procedure TSXLIB.InitInt10
    TopSpeed compiler dependencies:
    ------ pragmas (*#...*)
  *)

  FROM Cfg IMPORT EXTTS;
  IMPORT SrvSys;

  (* ================== Conditional import *)

  (*%T EXTTS*)
  IMPORT TSXLIB;
  (*%E*)

  (* ==================== Hardware/OpSystem interface *)

  CONST
    VideoInterrupt = 10H;
    SpecialFun = 1200H;
    GetConfigSubFun = 10H;
    ReadDisplayCombFun = 1A00H;

  TYPE
    BIOSCode =
      (NoDisplay, MDA5151, CGA5153or5154, c3, EGA5153or5154, EGA5151,
      PGA5175, VGAMono, VGAColor, c9, c10, MCGAMono, MCGAColor);

  PROCEDURE EGATest(): BOOLEAN;
    VAR
      reg: SrvSys.Registers;
    BEGIN
      reg.AX := SpecialFun;
      reg.BL := GetConfigSubFun;
      SrvSys.Int(reg, VideoInterrupt);
      RETURN reg.BL # GetConfigSubFun;
    END EGATest;

  PROCEDURE VGATest(VAR x: Adapter): BOOLEAN;
    VAR
      reg: SrvSys.Registers;
    BEGIN
      reg.AX := ReadDisplayCombFun;
      SrvSys.Int(reg, VideoInterrupt);
      IF ORD(reg.AL) = (ReadDisplayCombFun DIV 256) THEN
        CASE VAL(BIOSCode, ORD(reg.BL)) OF
        | MDA5151:
          x := mda;
        | CGA5153or5154:
          x := cga;
        | EGA5153or5154, EGA5151:
          x := ega;
        | VGAMono, VGAColor:
          x := vga;
        | MCGAMono, MCGAColor:
          x := mcga;
        ELSE
          x := unknown;
        END;
        RETURN TRUE;
      ELSE
        RETURN FALSE;
      END;
    END VGATest;

  (* =============================== Initialization *)

  BEGIN
    (* ------------ initialize the interceptor *)
  (*%T EXTTS*)
    TSXLIB.InitInt10();
  (*%E*)
    (* ------------------------- determine the adapter *)
    IF NOT VGATest(adapter) THEN
      IF EGATest() THEN
        adapter := ega;
      ELSE
        adapter := unknown;
      END;
    END;
  END ScrBas.
